#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl
use strict;
use HTML::Template;
use PureMessage::Manager::Request qw($REQUEST %in);
use PureMessage::Manager::Response::Policy;
use PureMessage::Manager::Widget;
use PureMessage::Manager::Widget::Template;
use PureMessage::Manager::Widget::Grid;
use PureMessage::Manager::Lang;
use PureMessage::Version qw($PREFIX);
use PureMessage::List;
use PureMessage::Map;
use PureMessage::List::Items qw(%MatchTypes @MatchListDefault);
use PureMessage::Map::Items qw(@MatchMapDefault);
use ActiveState::Config qw(:path);
use HTML::Entities;

my %vars;

my $WIDTH="100%";
my $WIDGET = new PureMessage::Manager::Widget;
my @lists;

my $r = $REQUEST->get_response( 'PureMessage::Manager::Response::Policy',
                                'stderr_to_stdout' =>1
                              );

$r->add_help(text => "Help", tab => "pol", page => "mgr_pol_man_lists" );

$r->{debug} = 0;
my $show_only = encode_entities($in{show_only},'&<>"\/\'') || 'list';
$r->title(text('lists_title',ucfirst($show_only)));

my $list_widget = get_lists_widget();

init_lists();

my $page_main = $list_widget;

my %match;
$match{list}->{$_} = $MatchTypes{$_} foreach (@MatchListDefault,@MatchMapDefault);
$match{'map'}->{$_} = $MatchTypes{$_} foreach @MatchMapDefault;

my $data = $list_widget->read_input($REQUEST) ? $list_widget->result_data() : {};
my $edit = $data->{edit} || $REQUEST->query('edit');
    
if ($edit) {
        # then show the edit page
        my $list = list_item($edit);
        if ($list) {
	        # Show the publication status/selector
		eval {
		    require PureMessage::Manager::Response::ServerGroups::Publications;

		    my $source = $list->{source};
		    if ($source =~ s/^file://) {
			$source =~ s/^$PREFIX\/*//;
			$r->print(PureMessage::Manager::Response::ServerGroups::Publications::Publish($source, 
												      $list->{name}, 
												      'obj_type'=>$show_only)); 
		    }
		};

                $vars{$_} = $list->{$_} foreach keys %$list;
                if ($list->{args}) {
                  $vars{"args_$_"} = $list->{args}->{$_} foreach keys %{$list->{args}};
                }
                if ($list->{source} =~ /^ldap:/) {
                  # Get LDAP hosts out of source
                  ($vars{ldap_server}) = ($list->{source} =~ /^ldap:(.*)/);
                  $vars{ldap} = 1;
                  $vars{source} = 'LDAP';
                }
                $vars{nocase} = $list->{comparator} eq 'i;octet' ? 0 : 1;
                $vars{type} = $list->{type};
                if ($list->{precious}) {
                  $vars{match_type}      = $list->{match_type};
                  $vars{match_type_desc} = $match{$list->{type}}->{$list->{match_type}};
                } else {
                  $vars{match_type} = $WIDGET->option_list('match_type',$match{$list->{type}}, $list->{match_type});
                }
                $vars{precious} = $list->{precious};
                my @buttons = ( { type=>'image', icon=>'save', text=>'Save', name=>$list_widget->make_form_name('save'),alt=>'Save'},
                                { type=>'image', icon=>'cancel',text=>'Cancel', name=>'cancel', alt=>'Cancel'},);
                               
                my $tb = $WIDGET->widget( CLASS=>'PureMessage::Manager::Widget::ToolBar',
                                                                buttons=>[\@buttons],
                                                                name=>'list_grid', # to keep these in the widget scope
                                                                state=>{'show_only' => $show_only },
                                                              );

                $vars{HEADER} = $r->ThemeSectionHeader(title=>"Edit " . ucfirst($vars{type}))->output;
                $vars{FOOTER} = $r->ThemeSectionFooter(toolbar=>$tb)->output;
                $page_main = $WIDGET->widget( CLASS=>'PureMessage::Manager::Widget::Template',
                                              filename => "lists_edit", data => \%vars,
                                              name=>'list_grid',
                                             );
        } else {
                $r->raise_error('cant find that list');
        }
} elsif($data->{save}) {
     my $list_type = $in{type};
     my $list = list_item($in{id});
     
     if(validData(\%in)) {
        my $l;
        my $t;

        eval {
            if ($list_type eq 'list') {
            
               $l = PureMessage::List->Config(writable=>1);    
               $t = 'list'
            } else {
               $l = PureMessage::Map->Config(writable=>1);    
               $t = 'map'
            }
             my $root = $l->root();
             my $m = $in{nocase} ? 'i;ascii-casemap' : 'i;octet';
             path_value($root,"$t#$list->{id}.name",$in{name}) if $in{name} ne $list->{name};
             path_value($root,"$t#$list->{id}.description",$in{description}) if $in{description} ne $list->{description};
            
             if (!$list->{precious}) {
                path_value($root,"$t#$list->{id}.match_type",$in{match_type}) if $in{match_type} ne $list->{match_type};
                path_value($root,"$t#$list->{id}.comparator",$m) if $m ne $list->{match_type};
                #path_value($root,"$t#$list->{id}.source",$in{source}) if $in{source} ne $list->{source};
             }
             foreach my $k (grep /^args_/, keys %in) {
                # place 'args' back into the list config
                my ($arg) = ($k =~ /^args_(.*)/);
                path_value($root,"$t#$list->{id}.args.$arg",$in{$k}) if ($in{$k} ne $list->{args}{$arg});
             }
             if ($list->{source} =~ /^ldap:/) {
                # re-assemble "source" using new 'ldap_server'
                my $newsource = 'ldap:' . $in{ldap_server};
                path_value($root,"$t#$list->{id}.source",$newsource) if ($newsource ne $list->{source});
             }
             $l->save();
        };
        if ($@) {
            $r->raise_error(text('error_editing_list',$show_only,$in{id},$@));
            reshow_list_edit();
        } else {
            $r->add_part($WIDGET->widget( CLASS=>'PureMessage::Manager::Widget::PaneBox',
                                          content=>text("list_edit_ok",$show_only,$in{id}),
                                          width=>$WIDTH,
                                        ),'list_ok');
            init_lists();
        }
        
     } else {
        reshow_list_edit();
    }
               
} elsif ( exists($data->{selected_data_rows}) and defined($data->{selected_data_rows}) ) {
        my @selected;
        push(@selected,$data->{selected_data_rows}) unless ref($data->{selected_data_rows}) eq 'ARRAY';
        @selected = @{$data->{selected_data_rows}} if ref($data->{selected_data_rows}) eq 'ARRAY';
        
        if($data->{'delete'}) {
                my @good;
                my @bad;
                foreach my $row (@selected) {
                       my $list = $lists[$row];
                       if ($list->{precious}) {
                                push(@bad,$row);
                                next;        
                       }

                        push(@good,$row);
                }
                if (@bad) {
                        my @d;
                        push(@d,$lists[$_]->{id}) foreach @bad;
                        
                        $r->add_part($WIDGET->widget( CLASS=>'PureMessage::Manager::Widget::PaneBox',
                                                              content=>text("cant_modify_precious",
                                                                            $show_only, 
                                                                            $#d > 0 ? 's':'',
                                                                            join('<LI>',@d)
                                                                           ),
                                                              width=>$WIDTH,
                                                    ),'list_ok');
                }
                if(@good) {
                   my @d;
                   push(@d,$lists[$_]->{id}) foreach @good;

                   $page_main = 
                    $r->Dialog( style => 'dlg_ok',
                                msg  =>text("ok_delete",$show_only,$#d > 0 ? 's':'',join('<LI>',@d)),
                                dialog_title=>text('ok_delete_title'),
                                title=>text('ok_delete_title'),
                                name=>'list_grid',
                                state=> { $list_widget->make_form_name('selected_row') => \@good,
                                          'show_only' => $show_only },
                                toolbar=> $WIDGET->widget('CLASS' => 'PureMessage::Manager::Widget::ToolBar',
                                                          embed=>1,
                                                          name=>'lists_grid',
                                                          action=>'lists.cgi',
                                                          buttons => [[ { type=>'image',name=>'yes_delete',icon=>'delete',text=>'Delete' },
                                                                        { type=>'image',name=>'cancel',icon=>'cancel',text=>'Cancel' },
                                                                     ]],
                                                         ),
                                );
                        
                }
                
        
        }elsif($data->{'yes_delete'}) {
                my @ok_deleted;
                my $MAP_AS = PureMessage::Map->Config(writable=>1);
                my $LIST_AS = PureMessage::List->Config(writable=>1);    
                foreach my $row (@selected) {
                        my $list = $lists[$row];
                        my $list_type = $list->{type};
                        
                        if (!$list) {                 
                                $r->raise_error(text('list_doesnt_exist'));
                                next;
                        }
                        if ($list->{precious}) {
                                $r->add_part($WIDGET->widget( CLASS=>'PureMessage::Manager::Widget::PaneBox', 
                                                              content=>text("cant_modify_precious",
                                                                            $show_only, 
                                                                            '',
                                                                            "<LI>$list->{id})",
                                                                           ),
                                                              width=>$WIDTH,
                                                             ),'list_ok');
                                next;        
                        }
                        
                        my $l;
                        my $t;

                        eval {
                                if ($list_type eq 'list') {
                    
                                        $l = $LIST_AS;
                                        $t = 'list'
                                } elsif($list_type eq 'map') {
                                        $l = $MAP_AS;
                                        $t = 'map'
                                } else {
                                        die text('bad_list_type_to_delete',$list->{id}) . "\n";
                                }
                                my $root = $l->root();
                                my $path = "$t#$list->{id}";
                                path_nodes($root,$path,delete=>1); 
                                my ($spec,$file) = split(':',$list->{source});
                                if ($spec eq 'file') {
                                        if (-e $file and -f _ and -r _) {
                                                unlink($file) || $r->raise_error('error_unlinking_file',$t,$file,$list->{id},$!);
                                        } else {
                                                $r->raise_error('cant_delete_source',$list->{id},$file,$t);
                                        }
                                } else {
                                        # do nothing I guess until there
                                        # are other types that need
                                        # delete actions done
                                }
                        };
                        if ($@) {
                                $r->raise_error('error_deleting_list',$list->{id},$show_only,$@);
                        } else {
                                push(@ok_deleted,$list->{id})
                        }    
                }
                
                if (@ok_deleted) {
                        $MAP_AS->save();
                        $LIST_AS->save();
                        $r->add_part($WIDGET->widget( CLASS=>'PureMessage::Manager::Widget::PaneBox',
                                                      content=>text("list_deleted_ok",$show_only,
                                                                    $#ok_deleted>0 ? 's':'',
                                                                    join('<BR>',@ok_deleted)),
                                                      width=>$WIDTH,
                                                     ),'list_ok');
                        init_lists();
                }

        }
}

my $tb;
$r->add_part($page_main,'list');

$r->send;

# subs

sub reshow_list_edit {

        $vars{$_} = $in{$_} foreach keys %in;
        if ($vars{precious}) {
          $vars{match_type} = $in{match_type};
        } else {
          $vars{match_type} = $WIDGET->option_list('match_type',$match{$in{type}},$in{match_type});
        }
        my @buttons = ( { type=>'image', icon=>'save', text=>'Save', name=>$list_widget->make_form_name('save'), alt=>'Save'},
                        { type=>'image', icon=>'cancel',text=>'Cancel', name=>'cancel', alt=>'Cancel'},);
                       
        my $tb = $WIDGET->widget( CLASS=>'PureMessage::Manager::Widget::ToolBar',
                                                        buttons=>[\@buttons],
                                                        name=>'lists_widget', # to keep these in the widget scope
                                                        state => { show_only => $show_only },
                                                      );

        
        $vars{HEADER} = $r->ThemeSectionHeader(title=>"Edit " . ucfirst($vars{type}))->output;
        $vars{FOOTER} = $r->ThemeSectionFooter(toolbar=>$tb)->output;
        $page_main = $WIDGET->widget( CLASS=>'PureMessage::Manager::Widget::Template',
                                      filename => "lists_edit", data => \%vars,
                                      name=>'lists_grid',
                                     );


}

sub validData {
        my $in = shift;
        $in->{match_type} = '' unless $in->{match_type}; # validator won't check keys that don't exists in input
                                                         # so force this to exist
        $REQUEST->typedecl("list_type", "#enum list map", "ListType");
        $REQUEST->typedecl("id", "#as_option #value", "Id");
        $REQUEST->typedecl("name", "#nomarkup #value", "Name");
        $REQUEST->typedecl("#match_type", 
            sub { die 'must select a valid match type' unless grep { $_[3] eq $_ } (@MatchListDefault,@MatchMapDefault); });

        $REQUEST->typedecl("match_type", "#match_type #value", "Match Type");
        $REQUEST->typedecl("description", "#nomarkup #value", "Description");

        if ($in->{ldap}) {
            $REQUEST->typedecl( 'ldap_server',   '#value', "LDAP Server" );
            $REQUEST->typedecl( 'args_dn',       '#str',   "DN for binding to LDAP server" );
            $REQUEST->typedecl( 'args_password', '#str',   "Password for binding to LDAP server" );
            $REQUEST->typedecl( 'args_base',     '#value', "Base DN for matching" );
            $REQUEST->typedecl( 'args_match',    '#value', "Filter to match list/map" );
        }

        my @v_errors = $REQUEST->validate($in);
        if (@v_errors) {
            $r->raise_error(join("<br>", @v_errors));
            return;
        } else {
            return 1;
        }
}



sub list_item{
        my  $id = shift;
        my $type = $show_only;
        my ($list,@junk) = grep { $_->{id} eq $id and (!$type or $_->{type} eq $type) } @lists;
        return $list;
}

sub init_lists {
        undef(@lists);
        if (!$show_only or ($show_only eq 'list')) {
                PureMessage::List->_config(1); #TODO: remove this when it's not needed
                foreach my $l (PureMessage::List->Available()) {
                        push(@lists,{ %$l, type=>'list' });        
                }
        }

        if (!$show_only or ($show_only eq 'map')) {
                PureMessage::Map->_config(1); #TODO: remove this when it's not needed
                foreach my $m (PureMessage::Map->Available()) {
                        push(@lists,{ %$m, type=>'map' });        
                }
        }

}

sub gen_list_data {
        my ($start,$end) = @_;
        my @data;
        if(defined($start) and defined($end) ) {
                for(my $i = $start; $i <= $end and $i <= $#lists; $i++) {
                        my %list = %{$lists[$i]};
                        push(@data,[button({ type=>'text', name=>$list_widget->make_form_name('edit'), 
                                              slave=>$list_widget->make_form_name('edit'), value=>$list{id},
                                              text=>clipLongStr($list{id},25) 
                                           }),
                                   clipLongStr($list{name},40),
                                   ucfirst($list{type}),
                                   clipLongStr($list{description},40),
                                   ]);

                }
                return \@data;
        } else {
                $#lists;
        }
}

sub get_lists_widget {

        my @buttons = ( { type=>'image', icon=>'delete', text=>'Delete', name=>'delete', alt=>'Delete'} );
        my $tb = $WIDGET->widget( CLASS=>'PureMessage::Manager::Widget::ToolBar',
                                                                        buttons=>[\@buttons],
                                                                        name=>'lists_grid',
                                                                      );

        my $lists_widget = $WIDGET->widget(CLASS => 'PureMessage::Manager::Widget::Grid',
                                    name => 'lists_grid',
                                    data => \&gen_list_data,
                                    page => 0,
                                    selectable=>0,
                                    page_size=>10,
                                    paging => 1,
                                    title=>text('dialog_list_title',ucfirst($show_only)),
                                    columns=>4,
                                    toolbar => $tb,
                                    state => { $tb->make_form_name('edit') => '', show_only => $show_only}, 
                                    width=>"100%",
                                    padding=>'<BR> <BR>',
                                    selectable => 1,
                                    action=>'lists.cgi',
                                    ddata => [
                                                { 
                                                  width=>"20%",
                                                  description=>'ID',
                                                  extra=>'nowrap',
                                                },
 
                                                { 
                                                  width=>"30%",
                                                  description=>'Name',
                                                  extra=>'nowrap',
                                                },
 
                                                { 
                                                  width=>"10%",
                                                  description=>'Type',
                                                  extra=>'nowrap',
                                                },
                                                { 
                                                  width=>"40%",
                                                  description=>'Description',
                                                  extra=>'nowrap',
                                                }, 

                                             ],
                                   );   

        return $lists_widget;
}


sub clipLongStr {
  my ($string,$len) = @_;
  return $string if length($string) <= $len;
  my $newString;
  $newString = substr($string,0,$len);
  return "$newString...";
}
